"use strict";

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var dob_1 = require("dob");
var shallow_eq_1 = require("shallow-eq");
var isUmount = Symbol();
var observerKey = Symbol();
var renderCountKey = Symbol();
var isDevtoolsEnabled = false;
function reportRendering() {
    console.log('render');
}
var emptyBaseRender = Symbol();
function patch(target, funcName) {
    var runMixinFirst = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;

    var base = target[funcName];
    var mixinFunc = reactiveMixin[funcName];
    if (!base) {
        target[funcName] = mixinFunc;
    } else {
        target[funcName] = runMixinFirst === true ? function () {
            for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
                args[_key] = arguments[_key];
            }

            mixinFunc.apply(this, args);
            base.apply(this, args);
        } : function () {
            for (var _len2 = arguments.length, args = Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
                args[_key2] = arguments[_key2];
            }

            base.apply(this, args);
            mixinFunc.apply(this, args);
        };
    }
}
var reactiveMixin = {
    componentWillMount: function componentWillMount() {
        var _this = this;

        var initialName = this.displayName || this.name || this.constructor && (this.constructor.displayName || this.constructor.name) || "<component>";
        var rootNodeID = this._reactInternalInstance && this._reactInternalInstance._rootNodeID;
        var isRenderingPending = false;
        var baseRender = this.render.bind(this);
        var self = this;
        var renderResult = emptyBaseRender;
        var initialRender = function initialRender() {
            var signal = void 0;
            if (!_this[observerKey]) {
                signal = dob_1.observe(function () {
                    if (isRenderingPending) {
                        return;
                    }
                    isRenderingPending = true;
                    renderResult = baseRender();
                    typeof self.componentWillReact === 'function' && _this[renderCountKey] && self.componentWillReact();
                    if (!self[isUmount] && _this[renderCountKey]) {
                        try {
                            React.Component.prototype.forceUpdate.call(self);
                        } catch (error) {
                            throw Error(error);
                        } finally {}
                    }
                    isRenderingPending = false;
                });
            }
            _this[observerKey] = signal;
            _this.render = reactiveRender;
            return reactiveRender();
        };
        var reactiveRender = function reactiveRender() {
            _this[renderCountKey] ? _this[renderCountKey]++ : _this[renderCountKey] = 1;
            if (renderResult !== emptyBaseRender) {
                var tempResult = renderResult;
                renderResult = emptyBaseRender;
                return tempResult;
            }
            return baseRender();
        };
        this.render = initialRender;
    },
    componentWillUnmount: function componentWillUnmount() {
        this[observerKey] && this[observerKey].unobserve();
        this[isUmount] = true;
    },
    componentDidMount: function componentDidMount() {
        if (isDevtoolsEnabled) {
            reportRendering();
        }
    },
    componentDidUpdate: function componentDidUpdate() {
        if (isDevtoolsEnabled) {
            reportRendering();
        }
    },
    shouldComponentUpdate: function shouldComponentUpdate(nextProps, nextState) {
        if (!shallow_eq_1.default(this.state, nextState)) {
            return true;
        }
        return !shallow_eq_1.default(this.props, nextProps);
    }
};
function mixinLifecycleEvents(target) {
    patch(target, 'componentWillMount', true);
    patch(target, 'componentDidMount');
    patch(target, 'componentWillUnmount');
    patch(target, 'componentDidUpdate');
    if (!target.shouldComponentUpdate) {
        target.shouldComponentUpdate = reactiveMixin.shouldComponentUpdate;
    }
}
function mixinAndInject(componentClass) {
    var extraInjection = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

    var target = componentClass.prototype || componentClass;
    mixinLifecycleEvents(target);
    return _a = function (_React$Component) {
        _inherits(InjectWrapper, _React$Component);

        function InjectWrapper() {
            _classCallCheck(this, InjectWrapper);

            return _possibleConstructorReturn(this, (InjectWrapper.__proto__ || Object.getPrototypeOf(InjectWrapper)).apply(this, arguments));
        }

        _createClass(InjectWrapper, [{
            key: "render",
            value: function render() {
                return React.createElement(componentClass, Object.assign({}, this.context.dyStores, this.props, extraInjection));
            }
        }]);

        return InjectWrapper;
    }(React.Component), _a.contextTypes = {
        dyStores: React.PropTypes.object
    }, _a;
    var _a;
}
function Connect(componentClass) {
    if (typeof componentClass === 'function' && (!componentClass.prototype || !componentClass.prototype.render) && !componentClass.isReactClass && !React.Component.isPrototypeOf(componentClass)) {
        return Connect(React.createClass({
            displayName: componentClass.displayName || componentClass.name,
            propTypes: componentClass.propTypes,
            contextTypes: componentClass.contextTypes,
            getDefaultProps: function getDefaultProps() {
                return componentClass.defaultProps;
            },
            render: function render() {
                return componentClass.call(this, this.props, this.context);
            }
        }));
    } else if ((typeof componentClass === "undefined" ? "undefined" : _typeof(componentClass)) === 'object') {
        var injectObj = {};
        for (var functionName in componentClass) {
            injectObj[functionName] = componentClass[functionName];
        }
        return function (realComponentClass) {
            return mixinAndInject(realComponentClass, injectObj);
        };
    }
    return mixinAndInject(componentClass);
}
exports.default = Connect;
//# sourceMappingURL=connect.js.map